#include <bits/stdc++.h>
using namespace std;

int main(int argc, char**argv){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
long long n, m; cin >> n >> m;
for ( int i = 0; i < m; i++ ){
    long long a, b, t; cin >> a >> b >> t;
}
long long u, v; cin >> u >> v;
cout << m - 2;
return 0;
}